
Audacious - OLD, PLEASE USE GITHUB DISCUSSIONS/ISSUES - Bug #1194

16MB limit opening m3u files

October 05, 2022 19:27 - Michael Purcell

Status: Closed Start date: October 05, 2022

Priority: Minor Due date:  

Assignee:  % Done: 0%

Category: libaudcore Estimated time: 0.00 hour

Target version: 4.3   

Affects version: 4.1   

Description

File -> Open Files -> [Navigate to Directory] -> Choose large.m3u file

Playlist truncated after about 16MB (after about 110000 entries with this playlist)

Remove comment lines using grep -v '^#'from large.m3u and playlist loads completely (currently 113224 entries)

This 16MB limit seems arbitrary, I would just expect audacious to continue to read m3u playlist until the end of file.

Audacious Version and OS level:

[root@music ~]# audacious -v

Audacious 4.1 (Fedora package)

[root@music ~]# uname -a

Linux music.purcell.lan 5.19.13-100.fc35.x86_64 #1 SMP PREEMPT_DYNAMIC Tue Oct 4 16:05:25 UTC 2022 x86_64 x86_64

x86_64 GNU/Linux

History

#1 - October 05, 2022 23:15 - Thomas Lange

The buffer size in VFSFile::read_all() is indeed limited to 16 MiB.

@John: Do you think we should increase it? Or can the m3u plugin use another approach to load the file?

https://github.com/audacious-media-player/audacious/blob/1a405f1cdbdd768ac41f1885366609f6ac4b333d/src/libaudcore/vfs.cc#L286

#2 - October 06, 2022 20:50 - John Lindgren

I suppose the easy fix would be to increase the limit. It is there simply to prevent a malicious (possibly remote) file from exhausting memory, but I

don't think there is anything magical about the 16 MiB number.  We could probably raise it to 256 MiB easily and still be fine as far as OOM scenarios.

#3 - October 13, 2022 17:07 - Thomas Lange

- Target version set to 4.2.1

- Category set to libaudcore

Fixed with https://github.com/audacious-media-player/audacious/commit/3e9217082538dbe72e0131e71baed3054eb6ceda.

Thanks for reporting.

#4 - October 13, 2022 17:08 - Thomas Lange

- Status changed from New to Closed
https://github.com/audacious-media-player/audacious/blob/1a405f1cdbdd768ac41f1885366609f6ac4b333d/src/libaudcore/vfs.cc#L286
https://github.com/audacious-media-player/audacious/commit/3e9217082538dbe72e0131e71baed3054eb6ceda


#5 - February 06, 2023 21:02 - John Lindgren

- Target version changed from 4.2.1 to 4.3
